import java.io.*;
import java.util.*;
          
public class GarbageGenerator {
// This program creates an output file of garbage based
// on a schema definition. Used to test the parser.

    static BufferedReader in;

    public GarbageGenerator() {
    }
     
    public static void main(String[] args) {
      in = new BufferedReader(new InputStreamReader(System.in));
      System.out.println("");
      System.out.println("Garbage Generator v1.0");                 
      System.out.println("====================\n");
      generateGarbage();
    }

    private static String getInput() {
	String input = "";
	int i = 0;
	try {
	    input = in.readLine();
	}
	catch (IOException e) {
	    e.printStackTrace();
	} 
	return input;
    }
	
	
    private static int getNum(String text) {
	int num = 0;
	try {
	    num = (new Integer(text)).intValue();
	}
	catch (NumberFormatException e) {
	    //System.out.println("Invalid value.");
	}
	return num;
    }
    
    public static void generateGarbage() {      
	in = new BufferedReader(new InputStreamReader(System.in));
	System.out.print("What Schema do you want to use? ");
	String schemaFileName = getInput();
	
	System.out.print("How many lines of garbage do you want? ");
	int numLines = getNum(getInput());
	if (numLines == 0)
	    numLines = 10;
	
	System.out.print("Where do you want to save the garbage? ");
	String fileName = getInput();
	Vector fields = openSchema(schemaFileName);
	
	System.out.println("");
	
	PrintWriter out = null;
	if (fileName.length() > 0) {
	    try {
		out = new PrintWriter(new FileOutputStream(fileName));
	    }
	    catch (IOException e) {
		e.printStackTrace();
	    }
	}
	for (int x = 0; x < numLines; x++) {
	    String temp = "";
	    for (int y = 0; y < fields.size(); y++) {
		Field f = (Field)fields.elementAt(y);
		if (y+1 != fields.size())
		    temp += f.getDelimiter();
		temp += createGarbage(f.getMinInLength(), f.getMaxInLength(), f.isVariable()); 
	    }
	    if (fileName.length() == 0)
		System.out.println(temp);
	    else {
		out.println(temp);
	    }
	    if ((x%1000 == 0) && (fileName.length() > 0) && (x>0))
		System.out.println(x + " lines processed.");
	}
	out.close();
	
    }


    private static String createGarbage(int min, int max, boolean variable) {
	String temp = "";
	int len = max;
	Random r = new Random();
	if (variable)
	    len = min + r.nextInt(max-min+1);
	
	
	for (int i = 0; i < len; i++) {
	    temp += r.nextInt(10);
	}
	return temp;
    }
	

    private static Vector openSchema(String fileName) {
	Vector fields = new Vector();
	SchemaDefinition sd = new SchemaDefinition(fileName);
	return sd.getFields();
    }

} 
