import java.util.*;
import java.io.*;

class MinirelEngine extends Engine {
// Engine for creating Minirel scripts

	public MinirelEngine() {

	}

    public String getInsert(SchemaDefinition sd, String data) {
	// Returns the Minirel insert script for the given line of data

		String temp = "insert " + sd.getTableName() + U.LPAREN;
		for (int i = 0; i < sd.getNumFields(); i++) {
			Field f = sd.getField(i);
			String value = sd.getFieldValue(i, data);
			if (value == null) // This field could not be processed
				return null;
			
			if (f.isIncluded()) {
				temp += f.getName() + "=";
				if (f.getOutType().compareTo("CHAR") == 0)
					temp += "\"" + value + "\"";
				else 
					temp += value;

				if (i != sd.getNumFields()-1)
					temp += ", ";
			}
		}
		temp += U.RPAREN + U.SEMI;
		return temp;
    }

    public String getCreateTable(SchemaDefinition sd) {
	// Minirel table creation script

		String temp = "create " + takeOutNonAlphas(sd.getTableName()) + U.LPAREN;
		for (int i = 0; i < sd.getNumFields(); i++) {
			Field f = sd.getField(i);
			if (f.isIncluded()) {
				temp += f.getName() + "=";              
				String type = f.getOutType();
				if (type.compareTo("CHAR") == 0)
					temp += "s" + f.getMaxOutLength();           
				else if (type.compareTo("INTEGER") == 0)
					temp += "i";  
				else if (type.compareTo("REAL") == 0)
					temp += "f";

				if (i != sd.getNumFields()-1)
					temp += ", ";        
			}
		}
		temp += U.RPAREN + U.SEMI;
		return temp;
    }                  

    public String quit() {
	return "quit;";
    }	

}


