import java.util.*;
import java.io.*;

class SQLEngine extends Engine {
// Engine for creating SQL-92 code 

	public SQLEngine() {

	}

    /* INSERT EXAMPLE */

    /*
      insert into employee
      (first, last, age, address, city,
      state)
      values ('Luke', 'Duke', 45, '2130
      Boars Nest', 'Hazard Co',
      'Georgia'); 
    */
  
    public String getInsert(SchemaDefinition sd, String data) {
	// Returns the SQL needed to insert the given data

		String temp = "INSERT INTO " + sd.getTableName() + U.LPAREN;
		for (int i = 0; i < sd.getNumFields(); i++) {
			Field f = sd.getField(i);
			if (f.isIncluded()) {
				temp += f.getName();
				if (i != sd.getNumFields()-1)
					temp += ", ";
			}
		}
		temp += U.RPAREN + " VALUES " + U.LPAREN;
		for (int i = 0; i < sd.getNumFields(); i++) {
			Field f = sd.getField(i);
			String value = sd.getFieldValue(i, data);
			if (value == null) // This field could not be processed
				return null;

			if (f.isIncluded()) {
				if (f.getOutType().compareTo("CHAR") == 0)
					temp += "'" + value + "'";
				else 
					temp += value;

				if (i != sd.getNumFields()-1)
					temp += ", ";
			}
		}
		temp += U.RPAREN;
		return temp;
    }

    /*CREATE EXAMPLE */
    /*
      create table employee
      (first varchar(15),
      last varchar(20),
      age number(3),
      address varchar(30),
      city varchar(20),
      state varchar(20));
    */

    public String getCreateTable(SchemaDefinition sd) {
	// SQL CREATE TABLE

		String temp = "CREATE TABLE " + takeOutNonAlphas(sd.getTableName()) + U.LPAREN;
		for (int i = 0; i < sd.getNumFields(); i++) {
			Field f = sd.getField(i);
			if (f.isIncluded()) {
				temp += f.getName() + " ";              
				String type = f.getOutType();
				if (type.compareTo("CHAR") == 0)
					temp += type + U.LPAREN + f.getMaxOutLength() + U.RPAREN;           
				else                                 
					temp += type;

				if (i != sd.getNumFields()-1)
					temp += ", ";        
			}
		}
		temp += U.RPAREN;
		return temp;
    }                  

    public String quit() {
	return "";
    }
	
}
