import java.util.*;
import java.io.*;
class Shell {

    // shell prompt

    private final static String PROMPT = "> ";
    private final static String DBDEVICE = "> /dev/db";
    private final static int NODBDEV = -1;

    public String dbname;

    Shell() {
    }

    
    public int redirectToDB(String com) {
	return com.indexOf(DBDEVICE);
    }

    public void interact(String com) throws IOException {
	int dbdev = redirectToDB(com);
	// is the command a redirection to a database?
	if (dbdev == NODBDEV) {
	    //no redirection to a database

	    //is the command a db related command?
	    
	    StringTokenizer st = new StringTokenizer(com);
	    String getFirst = st.nextToken();
	    if (getFirst.equals("db")) {
		String getFlag = st.nextToken();
		if (getFlag.equals("-c")) {
		    com = "./db_connect.pl ";
		    if (st.hasMoreTokens()) {
			dbname = st.nextToken();
			com += dbname;
		    }
		    else {
			U.println("you must specify a database");
			return;
		    }
		}
		if (getFlag.equals("-d")) {
		    com = "./db_disconnect.pl ";
		    if (st.hasMoreTokens()) {
			dbname = st.nextToken();
			com += dbname;
		    }
		    else {
			U.println("you must specify a database");
			return;
		    }
		}

		if (getFlag.equals("-x")) {
		    com = "./db_execute.pl ";
		    while (st.hasMoreTokens()) {
			com += st.nextToken() + " ";
		    }
		}
		if (getFlag.equals("-h")) {
		    usage();
		    return;
		}
	   
	    }
	    
	    UserCommand userCommand = new UserCommand(com);
	    Thread t = new Thread(userCommand);
	    t.run();
	    userCommand.printResults();
	}
	else {
	    //db interaction
	    File dbf = new File("db_env_name");
	    if (!dbf.exists()) {
		U.println("Not connected");
		return;
	    }
	    String commandName = com.substring(0,dbdev);
	    String fileName = Engine.takeOutNonAlphas(commandName);
	    String tableName = 
		com.substring(dbdev + DBDEVICE.length()+1,com.length());
	    U.println("tableName is " + tableName);
	    UserCommand userCommand = new UserCommand(commandName);
	    Thread t = new Thread(userCommand);
	    t.run();
	    U.println(fileName);
	    File f = new File(fileName);
	    if (!f.exists()) {

		//no schema exists for this command.
		U.println("Schema does not exist");
		String[] args = {fileName,tableName};
		SchemaDefiner.main(args);
	    }
	    Exec.populateDB(dbname, fileName, tableName, userCommand.bfr);
	}
    }
    
    public void getDataFromGUI(String com) throws IOException {
	U.println("don't know this command\n");
	//U.println("loading up the GUI\n");
	//GUI gui = new GUI(this,com);
    }

    public boolean userQuit(String s) {
	return (s.equals("quit") || s.equals("exit") || s.equals("q"));
    }

    public void ShellProgram() throws IOException, 
    FileNotFoundException{
	U.println("Welcome to the Shell");
	BufferedReader bfr = new BufferedReader
	    (new InputStreamReader(System.in));
	//try {
	    //readInKnownSchemas();
	//}
	//catch (FileNotFoundException e) {
	    //e.printStackTrace();
	//}
	U.print(PROMPT);
	String s = bfr.readLine();
	while(!userQuit(s)) {
	    if (!s.equals("")) {
		interact(s);
	    }
	    U.print(PROMPT);
	    s = bfr.readLine();
	}
	//writeOutKnownSchemas();
    }

    public static void test() throws IOException, 
    FileNotFoundException{
	String[] fields = {"perm"};
	int[] minSizes = {1};
	int[] maxSizes = {5};
	String[] delimiters = {","};
	//writeOutKnownSchemas();
    }

    public static void usage() {
	U.println("<DBname> can be either PG, MR, or SQL");
	U.println("PG: Postgres\tMR: Minirel\tSQL: Sybase");
	U.println("\t'db -h' to get this help menu");
	U.println("\t'db -c <DBname>' connects");
	U.println("\t'db -d <DBname>' disconnects");
	U.println("\t'db -x <command>' executes <command>");
	
	//U.println("<dbtitle> is the name of the database you wish to use");
    }

    public static void main(String args[]) throws IOException, 
    FileNotFoundException{
	usage();
	Exec.dbtitle = System.getProperty("user.name");
	Shell mainShell = new Shell();
	mainShell.dbname = "PG";

	mainShell.ShellProgram();
	//mainShell.interact("ls -lR /afs/cs.wisc.edu/u/m/d/md > /dev/db/oz");
	//mainShell.interact("ls -l > /dev/db/oz");
	//mainShell.interact("ls -lR /u/b/d/bduphoff > /dev/db/oz");
	//mainShell.interact("cat test > /dev/db/lsl");
    }
}





